/*
 * Include File Declarations
 */

#include <Xm/MainW.h>
#include <Xm/PushBG.h>
#include <Xm/MessageB.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/RowColumn.h>
#include <Xm/Frame.h>
#include <Xm/DrawingA.h>
#include <Xm/ToggleB.h>
#include <Xm/ToggleBG.h>
#include "bitmaps/flagup"
#include "bitmaps/backgnd.nu"
#include "bitmaps/gbr"

#define XBMu_BITS    flagup_bits
#define XBMu_WIDTH    flagup_width
#define XBMu_HEIGHT   flagup_height
#define XBMn_BITS    backgnd_bits
#define XBMn_WIDTH   backgnd_width
#define XBMn_HEIGHT  backgnd_height
#define XBMg_BITS    gbr_bits
#define XBMg_WIDTH   gbr_width
#define XBMg_HEIGHT  gbr_height
#define MAX_ARGS  20
#define BUFFERSZ  1000

/*
 * Global Variables
 */

static XmStringCharSet charset = (XmStringCharSet) XmSTRING_DEFAULT_CHARSET;

Widget appshell, bboard, drawarea, tbutton1, tbutton2, tbutton3;
Widget dlog_shell;
Arg args [20];
int n;
Pixmap px_up;
Pixmap nu;
Pixmap gbr;

/*-------------------------------------------------------------
** Forward Declarations
*/

void main();
void armCB1 ();
void armCB2 ();
void armCB3 ();
Widget Create_Draw_Dialog ();
Widget CreateHelp ();
void HelpCB ();
void QuitCB ();

static XtArgVal GetPixel(colorstr)
char *colorstr;
{
  XrmValue from, to;

  from.size = strlen(colorstr) +1;
  if (from.size < sizeof(String)) from.size = sizeof(String);
  from.addr = colorstr;
  to.addr = NULL;
  XtConvert(appshell, XmRString, &from, XmRPixel, &to);

  return ((XtArgVal) *((XtArgVal *) to.addr));
}

/*-------------------------------------------------------------
**  HelpCB      - callback for help button
*/
void HelpCB (w, client_data, call_data) 
Widget    w;    /*  widget id    */
XtPointer    client_data;  /*  data from application   */
XtPointer    call_data;  /*  data from widget class  */
{
  Widget    message_box;    /*  message box    */


  /*  Create help window. */
  message_box = CreateHelp (w);


  /*  Display help window. */
  XtManageChild (message_box);
}

/*-------------------------------------------------------------
**  CreateHelp    - create help window
*/
Widget CreateHelp (parent) 
  Widget    parent;    /*  parent widget  */
{
  Widget    button;
  Widget    message_box;  /*  Message Dialog   */
  Arg    args[MAX_ARGS];  /*  arg list    */
  register int  n;    /*  arg count    */

  static char  message[BUFFERSZ];  /*  help text  */
  XmString  title_string = NULL;
  XmString  message_string = NULL;
  XmString  button_string = NULL;



  /*  Generate message to display. */
  sprintf (message, "\
This program shows you how to create and use toggle button widgets and\n\
gadgets.  When you press one of the three buttons, a dialog box pops up\n\
with a drawing area widget that displays a canned drawing.  You can \n\
display as many of these as you want.  To terminate the program, press \n\
the 'Exit' button and then the 'Quit' button.\0");

  /* Create the compound strings */
  message_string = XmStringCreateLtoR (message, charset);
  button_string = XmStringCreateLtoR ("Close", charset);
  title_string = XmStringCreateLtoR ("drawnbtns help", charset);


  /*  Create message box dialog. */
  n = 0;
  XtSetArg (args[n], XmNdialogTitle, title_string);  n++;
  XtSetArg (args[n], XmNokLabelString, button_string);  n++;
  XtSetArg (args[n], XmNmessageString, message_string);  n++;
  message_box = XmCreateMessageDialog (parent, "helpbox", args, n);

  button = XmMessageBoxGetChild (message_box, XmDIALOG_CANCEL_BUTTON);
  XtUnmanageChild (button);
  button = XmMessageBoxGetChild (message_box, XmDIALOG_HELP_BUTTON);
  XtUnmanageChild (button);


  /*  Free strings and return message box. */
  if (title_string) XtFree (title_string);
  if (message_string) XtFree (message_string);
  if (button_string) XtFree (button_string);
  return (message_box);
}


/*-------------------------------------------------------------
**  QuitCB      - callback for quit button
*/
void QuitCB (w, client_data, call_data) 
Widget    w;    /*  widget id    */
XtPointer    client_data;  /*  data from application   */
XtPointer    call_data;  /*  data from widget class  */
{


  /*  Terminate the application. */
  exit (0);
}

/***********************************************************************
 ***               Create_Draw_Dialog             ***
 ***********************************************************************/
Widget Create_Draw_Dialog (parent)
 Widget parent;
 {

/*
 * Check to see if a dialog shell exists; if it does, destroy it.
 */ 
 if (dlog_shell) XtDestroyWidget (dlog_shell);

/*
 * Create a dialog shell
 */ 
 dlog_shell = XmCreateDialogShell (parent, "dlog_shell", NULL, 0);

/*
 * Create a drawing area
 */ 

 n = 0;
 XtSetArg(args[n], XmNwidth, 155); n++;
 XtSetArg(args[n], XmNheight, 155); n++;
 drawarea = XmCreateDrawingArea (dlog_shell, "drawarea", args, n);
 XtManageChild(drawarea);

 }

/***********************************************************************
 ***               armCB1             ***
 ***********************************************************************/
void armCB1(w, client_data, call_data)
 Widget w;
 XtPointer client_data;
 XtPointer call_data;
 {
 Widget draw_area_dialog;

/*
 * Check to see if a dialog shell already exists; if it does, destroy it
 */
 if (dlog_shell) XtDestroyWidget (dlog_shell);

 draw_area_dialog = Create_Draw_Dialog (appshell);
  
 n=0;
 XtSetArg(args[n], XmNbackgroundPixmap, px_up); n++;
 XtSetValues (drawarea, args, n);
 printf("Drawing area background set to flag up.\n");
 }

/***********************************************************************
 ***               armCB2             ***
 ***********************************************************************/
void armCB2(w, client_data, call_data)
 Widget w;
 XtPointer client_data;
 XtPointer call_data;
 {
 Widget draw_area_dialog;

/*
 * Check to see if a dialog shell already exists; if it does, destroy it
 */
 if (dlog_shell) XtDestroyWidget (dlog_shell);

 draw_area_dialog = Create_Draw_Dialog (appshell);
  
 n=0;
 XtSetArg(args[n], XmNbackgroundPixmap, nu); n++;
 XtSetValues (drawarea, args, n);
 printf("Drawing area background set to NU.\n");
 }

/***********************************************************************
 ***               armCB3             ***
 ***********************************************************************/
void armCB3(w, client_data, call_data)
 Widget w;
 XtPointer client_data;
 XtPointer call_data;
 {
 Widget draw_area_dialog;

/*
 * Check to see if a dialog shell already exists; if it does, destroy it
 */
 if (dlog_shell) XtDestroyWidget (dlog_shell);

 draw_area_dialog = Create_Draw_Dialog (appshell);
  
 n=0;
 XtSetArg(args[n], XmNbackgroundPixmap, gbr); n++;
 XtSetValues (drawarea, args, n);
 printf("Drawing area background set to GBR.\n");
 }

/***********************************************************************
 ***               MAIN                ***
 ***********************************************************************/
void main(argc, argv)
 unsigned int argc;
 char **argv;
{
  Widget rowcol, frame, main_window, menu_bar, menu_pane, cascade, button;
  XmString tblabel;
  XtAppContext app_context;
  Display *display;
  char *tbtext1 = "FLAG UP (Widget)";
  char *tbtext2 = "NU (Gadget)";
  char *tbtext3 = "GBR (Widget)";

/*
 * Initialize the appshell shell widget
 */
  appshell = XtAppInitialize(&app_context, "Toggles", NULL, 0, &argc,
                             argv, NULL, args, 0);

/*
 * Get the display ID for the bitmap to pixmap conversion
 */
 display = XtDisplay (appshell);

 /* Create main window.
 */
 n = 0;
 main_window = XmCreateMainWindow (appshell, "main1", args, n);
 XtManageChild (main_window);

 /* Create menu bar in main window. */
 n = 0;
 menu_bar = XmCreateMenuBar (main_window, "menu_bar", args, n); 
 XtManageChild (menu_bar);

 /* Create "Exit" pulldown menu. */
 n = 0;
 menu_pane = XmCreatePulldownMenu (menu_bar, "menu_pane", args, n);

 n = 0;
 button = XmCreatePushButtonGadget (menu_pane, "Quit", args, n);
 XtManageChild (button);
 XtAddCallback (button, XmNactivateCallback, QuitCB, NULL);

 n = 0;
 XtSetArg (args[n], XmNsubMenuId, menu_pane); n++;
 cascade = XmCreateCascadeButton (menu_bar, "Exit", args, n);
 XtManageChild (cascade);

 /* Create "Help" button. */
 n = 0;
 cascade = XmCreateCascadeButton (menu_bar, "Help", args, n);
 XtManageChild (cascade);
 XtAddCallback (cascade, XmNactivateCallback, HelpCB, NULL);

 n = 0;
 XtSetArg (args[n], XmNmenuHelpWidget, cascade); n++;
 XtSetValues (menu_bar, args, n);

/*
 * Create a frame widget
 */
 n = 0;
 /* XtSetArg(args[n], XmNwidth, 240); n++;
 XtSetArg(args[n], XmNheight, 90); n++; */
 XtSetArg(args[n], XmNmarginWidth, 15); n++;
 XtSetArg(args[n], XmNmarginHeight, 15); n++;
 frame = XmCreateFrame (main_window, "frame", args, n);
 XtManageChild(frame);

/*  Set main window areas  */
 XmMainWindowSetAreas (main_window, menu_bar, NULL, NULL, NULL, frame);

/*
 * Get pixmaps from bitmaps
 */
  px_up =XCreatePixmapFromBitmapData(display, 
    DefaultRootWindow(display),
    XBMu_BITS, XBMu_WIDTH,XBMu_HEIGHT,
    GetPixel("red"),
    GetPixel("white"),
    DefaultDepth(display,DefaultScreen(display)));

  nu = XCreatePixmapFromBitmapData(display, 
    DefaultRootWindow(display),
    XBMn_BITS, XBMn_WIDTH,XBMn_HEIGHT,
    GetPixel("red"),
    GetPixel("white"),
    DefaultDepth(display,DefaultScreen(display)));

  gbr = XCreatePixmapFromBitmapData(display, 
    DefaultRootWindow(display),
    XBMg_BITS, XBMg_WIDTH,XBMg_HEIGHT,
    GetPixel("white"),
    GetPixel("red"), 
    DefaultDepth(display,DefaultScreen(display)));

/*
 * Create a row column manager
*/
  n = 0;
  XtSetArg(args[n], XmNpacking, XmPACK_COLUMN); n++;
  XtSetArg(args[n], XmNspacing, 5); n++;
  rowcol = XmCreateRadioBox(frame, "rowcol", args, n);
  XtManageChild(rowcol);
  
/*
 * Create a compound string for the first toggle button label
 */
  tblabel = XmStringCreateLtoR(tbtext1, XmSTRING_DEFAULT_CHARSET);
  
/*
 * Create a toggle button
*/
  n = 0;
  XtSetArg(args[n], XmNlabelString, tblabel); n++;
  XtSetArg(args[n], XmNshadowThickness, 3); n++;
  tbutton1 = XmCreateToggleButton(rowcol, "tbutton1", args, n);
  XtManageChild(tbutton1);
  XmStringFree (tblabel);

/*
 * Add Callback for this button
 */ 
 XtAddCallback (tbutton1, XmNarmCallback, armCB1, NULL);

/*
 * Create a compound string for the toggle button gadget label
 */
  tblabel = XmStringCreateLtoR(tbtext2, XmSTRING_DEFAULT_CHARSET);
  
/*
 * Create a toggle button gadget
*/
  n = 0;
  XtSetArg(args[n], XmNlabelString, tblabel); n++;
  XtSetArg(args[n], XmNshadowThickness, 3); n++;
  tbutton2 = XmCreateToggleButtonGadget(rowcol, "tbutton2", args, n);
  XtManageChild(tbutton2);
  XmStringFree(tblabel);

/*
 * Add Callback for this button
 */ 
 XtAddCallback (tbutton2, XmNarmCallback, armCB2, NULL);

/*
 * Create a compound string for the toggle button label
 */
  tblabel = XmStringCreateLtoR(tbtext3, XmSTRING_DEFAULT_CHARSET);
  
/*
 * Create a toggle button
*/
  n = 0;
  XtSetArg(args[n], XmNlabelString, tblabel); n++;
  XtSetArg(args[n], XmNshadowThickness, 3); n++;
  tbutton3 = XmCreateToggleButton(rowcol, "tbutton3", args, n);
  XtManageChild(tbutton3);
  XmStringFree (tblabel);

/*
 * Add Callback for this button
 */ 
 XtAddCallback (tbutton3, XmNarmCallback, armCB3, NULL);

/*
 * Realize the appshell widget, which displays all children
 */ 
  XtRealizeWidget(appshell);

/*
 * Go into a loop and wait for input
 */
  XtAppMainLoop(app_context);
}
